/**
 * 最初の著者:: トゥイー
 * リポジトリ情報:: $Id: CountPSListener.hpp 11 2011-05-14 02:11:18Z yutaka_at_home $
 * 著作権:: Copyright (C) Ownway.info, 2011. All rights reserved.
 * ライセンス:: CPL(Common Public Licence)
 */

#ifndef _TOPS_COUNT_PS_LISTENER_HPP_
#define _TOPS_COUNT_PS_LISTENER_HPP_

#include "tops/PSListener.hpp"

#include <boost/shared_ptr.hpp>

namespace tops {

	/**
	 * プロダクションシステムに発生したイベントをカウントするリスナです。
	 *
	 * @author トゥイー
	 */
	class CountPSListener : public PSListener {
	private:
		int countOfAddedWMElement_;
		int countOfAddedProductionRule_;
		int countOfAddedAttribute_;

	public:
		/**
		 * リスナを構築します。
		 */
		CountPSListener() :
		countOfAddedWMElement_(0), countOfAddedProductionRule_(0), countOfAddedAttribute_(0) {
		}

	public:
		int sizeOfAddedWMElement() const {
			return countOfAddedWMElement_;
		}

		int sizeOfAddedProductionRule() const {
			return countOfAddedProductionRule_;
		}

		int sizeOfAddedAttribute() const {
			return countOfAddedAttribute_;
		}

	public:
		/**
		 * ワーキングメモリ要素が追加されたときに呼び出されます。
		 */
		void added(ProductionSystem& system, WMElement& element) {
			++countOfAddedWMElement_;
		}

		/**
		 * プロダクションルールが追加されたときに呼び出されます。
		 */
		void added(ProductionSystem& system, ProductionRule& productionRule) {
			++countOfAddedProductionRule_;
		}

		/**
		 * 属性が追加されたときに呼び出されます。
		 */
		void added(ProductionSystem& system,
		           WMElement& element, const std::string& name, const ConstantPtr& constant) {
			++countOfAddedAttribute_;
		}
	};

	typedef boost::shared_ptr<CountPSListener> CountPSListenerPtr;

}  // namespace tops

#endif
